diff --git a/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index af75de9de..7e51a4f22 100644
--- a/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -14,7 +14,7 @@ import net.minecraft.client.gui.guidebook.GuidebookPageManager;
 import net.minecraft.client.gui.guidebook.ScreenGuidebook;
 import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
 import net.minecraft.client.player.controller.PlayerControllerMP;
-import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldClientMP;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.TileEntityActivator;
@@ -85,7 +85,7 @@ public class PacketHandlerClient extends PacketHandler
     private final NetworkManager netManager;
     public String message; // Name from b1.2 leak
     private final Minecraft mc;
-    private WorldClient worldClient;
+    private WorldClientMP worldClientMP;
     private boolean started; // Name from b1.2 leak
     public SavedDataStorage savedDataStorage;
     public List<PlayerProfile> players;
@@ -155,9 +155,9 @@ public class PacketHandlerClient extends PacketHandler
     {
         mc.playerController = new PlayerControllerMP(mc, this);
         mc.statsCounter.add(StatList.joinMultiplayerStat, 1);
-        worldClient = new WorldClient(mc, this, loginPacket.worldSeed, loginPacket.dimensionId, loginPacket.worldTypeId);
-        worldClient.isClientSide = true;
-        mc.changeWorld(worldClient);
+        worldClientMP = new WorldClientMP(this, loginPacket.worldSeed, loginPacket.dimensionId, loginPacket.worldTypeId);
+        worldClientMP.isClientSide = true;
+        mc.changeWorld(worldClientMP);
         mc.thePlayer.dimension = loginPacket.dimensionId;
         mc.displayScreen(new ScreenDownloadTerrain(this));
         mc.thePlayer.id = loginPacket.playerEntityIdAndProtocolVersion;
@@ -171,14 +171,14 @@ public class PacketHandlerClient extends PacketHandler
         double x = addItemEntityPacket.xPosition / 32D;
         double y = addItemEntityPacket.yPosition / 32D;
         double z = addItemEntityPacket.zPosition / 32D;
-        EntityItem entityItem = new EntityItem(worldClient, x, y, z, new ItemStack(addItemEntityPacket.itemID, addItemEntityPacket.count, addItemEntityPacket.itemDamage, addItemEntityPacket.tag));
+        EntityItem entityItem = new EntityItem(worldClientMP, x, y, z, new ItemStack(addItemEntityPacket.itemID, addItemEntityPacket.count, addItemEntityPacket.itemDamage, addItemEntityPacket.tag));
         entityItem.xd = (double) addItemEntityPacket.xd / 128D;
         entityItem.yd = (double) addItemEntityPacket.yd / 128D;
         entityItem.zd = (double) addItemEntityPacket.zd / 128D;
         entityItem.serverPosX = addItemEntityPacket.xPosition;
         entityItem.serverPosY = addItemEntityPacket.yPosition;
         entityItem.serverPosZ = addItemEntityPacket.zPosition;
-        worldClient.addEntityToWorld(addItemEntityPacket.entityId, entityItem);
+        worldClientMP.addEntityToWorld(addItemEntityPacket.entityId, entityItem);
     }
 
 
@@ -194,7 +194,7 @@ public class PacketHandlerClient extends PacketHandler
         } else {
             owner = null;
         }
-        Entity newEntity = NetEntityHandler.getTypeEntry(addEntityPacket.type).getEntity(worldClient, xPosition, yPosition, zPosition, addEntityPacket.metaData, addEntityPacket.hasVelocity, addEntityPacket.xVelocity / 8000D, addEntityPacket.yVelocity / 8000D, addEntityPacket.zVelocity / 8000D, owner);
+        Entity newEntity = NetEntityHandler.getTypeEntry(addEntityPacket.type).getEntity(worldClientMP, xPosition, yPosition, zPosition, addEntityPacket.metaData, addEntityPacket.hasVelocity, addEntityPacket.xVelocity / 8000D, addEntityPacket.yVelocity / 8000D, addEntityPacket.zVelocity / 8000D, owner);
         if (newEntity != null) {
             newEntity.serverPosX = addEntityPacket.xPosition;
             newEntity.serverPosY = addEntityPacket.yPosition;
@@ -202,7 +202,7 @@ public class PacketHandlerClient extends PacketHandler
             newEntity.yRot = addEntityPacket.yaw;
             newEntity.xRot = addEntityPacket.pitch;
             newEntity.id = addEntityPacket.entityId;
-            worldClient.addEntityToWorld(addEntityPacket.entityId, newEntity);
+            worldClientMP.addEntityToWorld(addEntityPacket.entityId, newEntity);
             if (owner instanceof Mob && newEntity instanceof Projectile){
                 ((Projectile) newEntity).owner = (Mob) owner;
             }
@@ -220,7 +220,7 @@ public class PacketHandlerClient extends PacketHandler
         double z = (double) weatherEffectPacket.z / 32D;
         Entity weatherEntity = null;
         if (weatherEffectPacket.effectId == WeatherEffectPacket.EFFECT_LIGHTNING) {
-            weatherEntity = new EntityLightning(worldClient, x, y, z);
+            weatherEntity = new EntityLightning(worldClientMP, x, y, z);
         }
         if (weatherEntity != null)
         {
@@ -230,23 +230,23 @@ public class PacketHandlerClient extends PacketHandler
             weatherEntity.yRot = 0.0F;
             weatherEntity.xRot = 0.0F;
             weatherEntity.id = weatherEffectPacket.id;
-            worldClient.addWeatherEffect(weatherEntity);
+            worldClientMP.addWeatherEffect(weatherEntity);
         }
     }
 
     @Override
     public void handleWeatherStatus(WeatherStatusPacket packet)
     {
-        if (worldClient.dimension.id != packet.dimId) return;
+        if (worldClientMP.dimension.id != packet.dimId) return;
         Weather currentWeather = packet.id == -1 ? null : Weathers.WEATHERS[packet.id];
         Weather newWeather = packet.newId == -1 ? null : Weathers.WEATHERS[packet.newId];
-        worldClient.weatherManager.overrideWeather(currentWeather, newWeather, packet.duration, packet.intensity, packet.power);
+        worldClientMP.weatherManager.overrideWeather(currentWeather, newWeather, packet.duration, packet.intensity, packet.power);
     }
 
     @Override
     public void handleEntityPainting(AddPaintingPacket addPaintingPacket)
     {
-        Entity entity = worldClient.getEntityFromId(addPaintingPacket.entityId);
+        Entity entity = worldClientMP.getEntityFromId(addPaintingPacket.entityId);
         if (entity instanceof EntityPainting){
             EntityPainting painting = (EntityPainting) entity;
             painting.blockX = addPaintingPacket.xPosition;
@@ -260,8 +260,8 @@ public class PacketHandlerClient extends PacketHandler
                 painting.setStack(new ItemStack(addPaintingPacket.itemID, 1, addPaintingPacket.meta));
             }
         } else {
-            EntityPainting entitypainting = new EntityPainting(worldClient, addPaintingPacket.xPosition, addPaintingPacket.yPosition, addPaintingPacket.zPosition, addPaintingPacket.direction, addPaintingPacket.key);
-            worldClient.addEntityToWorld(addPaintingPacket.entityId, entitypainting);
+            EntityPainting entitypainting = new EntityPainting(worldClientMP, addPaintingPacket.xPosition, addPaintingPacket.yPosition, addPaintingPacket.zPosition, addPaintingPacket.direction, addPaintingPacket.key);
+            worldClientMP.addEntityToWorld(addPaintingPacket.entityId, entitypainting);
             if (addPaintingPacket.itemID > 0){
                 entitypainting.setStack(new ItemStack(addPaintingPacket.itemID, 1, addPaintingPacket.meta));
             }
@@ -273,14 +273,8 @@ public class PacketHandlerClient extends PacketHandler
     public void handleEntityVelocity(SetEntityMotionPacket setEntityMotionPacket)
     {
         Entity entity = getEntityByID(setEntityMotionPacket.entityId);
-        if (entity == null)
-        {
-            return;
-        }
-        else
-        {
+        if (entity != null) {
             entity.lerpMotion((double) setEntityMotionPacket.motionX / 8000D, (double) setEntityMotionPacket.motionY / 8000D, (double) setEntityMotionPacket.motionZ / 8000D);
-            return;
         }
     }
 
@@ -302,7 +296,7 @@ public class PacketHandlerClient extends PacketHandler
         double d2 = (double) addPlayerPacket.zPosition / 32D;
         float f = (float) (addPlayerPacket.rotation * 360) / 256F;
         float f1 = (float) (addPlayerPacket.pitch * 360) / 256F;
-        PlayerRemote playerRemote = new PlayerRemote(mc.theWorld, addPlayerPacket.name, addPlayerPacket.uuid);
+        PlayerRemote playerRemote = new PlayerRemote(mc.currentWorld, addPlayerPacket.name, addPlayerPacket.uuid);
         playerRemote.xo = playerRemote.serverPosX = addPlayerPacket.xPosition;
         playerRemote.yo = playerRemote.serverPosY = addPlayerPacket.yPosition;
         playerRemote.zo = playerRemote.serverPosZ = addPlayerPacket.zPosition;
@@ -316,7 +310,7 @@ public class PacketHandlerClient extends PacketHandler
             playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentItemIndex()] = new ItemStack(i, 1, 0);
         }
         playerRemote.absMoveTo(d, d1, d2, f, f1);
-        worldClient.addEntityToWorld(addPlayerPacket.entityId, playerRemote);
+        worldClientMP.addEntityToWorld(addPlayerPacket.entityId, playerRemote);
         playerRemote.nickname = StringUtils.substring(addPlayerPacket.nickname, 0, 32);
         playerRemote.chatColor = addPlayerPacket.chatColor;
 
@@ -327,12 +321,7 @@ public class PacketHandlerClient extends PacketHandler
     public void handleEntityTeleport(TeleportEntityPacket teleportEntityPacket)
     {
         Entity entity = getEntityByID(teleportEntityPacket.id);
-        if (entity == null)
-        {
-            return;
-        }
-        else
-        {
+        if (entity != null) {
             entity.serverPosX = teleportEntityPacket.x;
             entity.serverPosY = teleportEntityPacket.y;
             entity.serverPosZ = teleportEntityPacket.z;
@@ -342,7 +331,6 @@ public class PacketHandlerClient extends PacketHandler
             float f = (float) (teleportEntityPacket.yaw * 360) / 256F;
             float f1 = (float) (teleportEntityPacket.pitch * 360) / 256F;
             entity.lerpTo(d, d1, d2, f, f1, 3);
-            return;
         }
     }
 
@@ -350,12 +338,7 @@ public class PacketHandlerClient extends PacketHandler
     public void handleEntity(MoveEntityPacket moveEntityPacket)
     {
         Entity entity = getEntityByID(moveEntityPacket.id);
-        if (entity == null)
-        {
-            return;
-        }
-        else
-        {
+        if (entity != null) {
             entity.serverPosX += moveEntityPacket.x;
             entity.serverPosY += moveEntityPacket.y;
             entity.serverPosZ += moveEntityPacket.z;
@@ -365,7 +348,6 @@ public class PacketHandlerClient extends PacketHandler
             float f = moveEntityPacket.rotating ? (float) (moveEntityPacket.yaw * 360) / 256F : entity.yRot;
             float f1 = moveEntityPacket.rotating ? (float) (moveEntityPacket.pitch * 360) / 256F : entity.xRot;
             entity.lerpTo(d, d1, d2, f, f1, 3);
-            return;
         }
     }
 
@@ -380,9 +362,9 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleSetMobSpawner(SetMobSpawnerPacket setMobSpawnerPacket)
     {
-        if (mc.theWorld.isBlockLoaded(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition))
+        if (mc.currentWorld.isBlockLoaded(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition))
         {
-            TileEntity tileentity = mc.theWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
+            TileEntity tileentity = mc.currentWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
             if (tileentity instanceof TileEntityMobSpawner)
             {
                 TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
@@ -401,7 +383,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleDestroyEntity(RemoveEntityPacket removeEntityPacket)
     {
-        worldClient.removeEntityFromWorld(removeEntityPacket.entityId);
+        worldClientMP.removeEntityFromWorld(removeEntityPacket.entityId);
     }
 
     @Override
@@ -444,7 +426,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handlePreChunk(ChunkVisibilityPacket chunkVisibilityPacket)
     {
-        worldClient.doPreChunk(chunkVisibilityPacket.chunkX, chunkVisibilityPacket.chunkZ, chunkVisibilityPacket.playerAdded);
+        worldClientMP.doPreChunk(chunkVisibilityPacket.chunkX, chunkVisibilityPacket.chunkZ, chunkVisibilityPacket.playerAdded);
     }
 
     @Override
@@ -460,9 +442,9 @@ public class PacketHandlerClient extends PacketHandler
             int x = coord >> 0 & 0xf;
             int y = coord >> 8 & 0xff;
             int z = coord >> 4 & 0xf;
-            worldClient.setBlockAndMetadataWithNotify(x + xBase, y, z + zBase, type, data);
-            worldClient.removePositionTypesInBounds(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
-            worldClient.markBlocksDirty(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
+            worldClientMP.setBlockAndMetadataWithNotify(x + xBase, y, z + zBase, type, data);
+            worldClientMP.removePositionTypesInBounds(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
+            worldClientMP.markBlocksDirty(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
         }
 
     }
@@ -470,14 +452,14 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleMapChunk(BlockRegionUpdatePacket blockRegionUpdatePacket)
     {
-        worldClient.removePositionTypesInBounds(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, (blockRegionUpdatePacket.xPosition + blockRegionUpdatePacket.xSize) - 1, (blockRegionUpdatePacket.yPosition + blockRegionUpdatePacket.ySize) - 1, (blockRegionUpdatePacket.zPosition + blockRegionUpdatePacket.zSize) - 1);
-        worldClient.setChunkData(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, blockRegionUpdatePacket.xSize, blockRegionUpdatePacket.ySize, blockRegionUpdatePacket.zSize, blockRegionUpdatePacket.chunk);
+        worldClientMP.removePositionTypesInBounds(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, (blockRegionUpdatePacket.xPosition + blockRegionUpdatePacket.xSize) - 1, (blockRegionUpdatePacket.yPosition + blockRegionUpdatePacket.ySize) - 1, (blockRegionUpdatePacket.zPosition + blockRegionUpdatePacket.zSize) - 1);
+        worldClientMP.setChunkData(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, blockRegionUpdatePacket.xSize, blockRegionUpdatePacket.ySize, blockRegionUpdatePacket.zSize, blockRegionUpdatePacket.chunk);
     }
 
     @Override
     public void handleBlockUpdate(BlockUpdatePacket blockUpdatePacket)
     {
-        worldClient.blockChange(blockUpdatePacket.xPosition, blockUpdatePacket.yPosition, blockUpdatePacket.zPosition, blockUpdatePacket.blockId, blockUpdatePacket.metadata);
+        worldClientMP.blockChange(blockUpdatePacket.xPosition, blockUpdatePacket.yPosition, blockUpdatePacket.zPosition, blockUpdatePacket.blockId, blockUpdatePacket.metadata);
     }
 
     @Override
@@ -539,9 +521,9 @@ public class PacketHandlerClient extends PacketHandler
         {
             // this class does not seem to handle pick up from server dropped items. find where it is.
             // something about that isn't working on servers if the player changed their gamemode.
-            worldClient.playSoundAtEntity(null, item, "item.pickup", 1F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 4.0F);
-            mc.particleEngine.add(new ParticlePickupAnimation(mc.theWorld, item, collector, -0.5F));
-            worldClient.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
+            worldClientMP.playSoundAtEntity(null, item, "item.pickup", 1F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 4.0F);
+            mc.particleEngine.add(new ParticlePickupAnimation(mc.currentWorld, item, collector, -0.5F));
+            worldClientMP.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
         }
     }
 
@@ -712,14 +694,14 @@ public class PacketHandlerClient extends PacketHandler
         double d2 = (double) addMobPacket.z / 32D;
         float f = (float) (addMobPacket.yaw * 360) / 256F;
         float f1 = (float) (addMobPacket.pitch * 360) / 256F;
-        Mob mob = (Mob) EntityDispatcher.createEntity(addMobPacket.type, mc.theWorld);
+        Mob mob = (Mob) EntityDispatcher.createEntity(addMobPacket.type, mc.currentWorld);
         mob.serverPosX = addMobPacket.x;
         mob.serverPosY = addMobPacket.y;
         mob.serverPosZ = addMobPacket.z;
         mob.id = addMobPacket.id;
         mob.absMoveTo(d, d1, d2, f, f1);
         mob.isMultiplayerEntity = true;
-        worldClient.addEntityToWorld(addMobPacket.id, mob);
+        worldClientMP.addEntityToWorld(addMobPacket.id, mob);
         List<SynchedEntityData.DataItem<?>> list = addMobPacket.getUnpackedData();
         if (list != null)
         {
@@ -732,14 +714,14 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleUpdateTime(SetTimePacket setTimePacket)
     {
-        mc.theWorld.setWorldTime(setTimePacket.time);
+        mc.currentWorld.setWorldTime(setTimePacket.time);
     }
 
     @Override
     public void handleSpawnPosition(SetSpawnPositionPacket setSpawnPositionPacket)
     {
         mc.thePlayer.setPlayerSpawnCoordinate(new ChunkCoordinates(setSpawnPositionPacket.x, setSpawnPositionPacket.y, setSpawnPositionPacket.z));
-        mc.theWorld.getLevelData().setSpawn(setSpawnPositionPacket.x, setSpawnPositionPacket.y, setSpawnPositionPacket.z);
+        mc.currentWorld.getLevelData().setSpawn(setSpawnPositionPacket.x, setSpawnPositionPacket.y, setSpawnPositionPacket.z);
     }
 
     @Override
@@ -752,7 +734,7 @@ public class PacketHandlerClient extends PacketHandler
             passenger = mc.thePlayer;
         }
         if (setRidingPacket.isTileEntity) {
-            vehicle = (IVehicle) worldClient.getBlockEntity(setRidingPacket.x, setRidingPacket.y, setRidingPacket.z);
+            vehicle = (IVehicle) worldClientMP.getBlockEntity(setRidingPacket.x, setRidingPacket.y, setRidingPacket.z);
         } else {
             vehicle = getEntityByID(setRidingPacket.vehicleId);
         }
@@ -779,7 +761,7 @@ public class PacketHandlerClient extends PacketHandler
         }
         else
         {
-            return worldClient.getEntityFromId(i);
+            return worldClientMP.getEntityFromId(i);
         }
     }
 
@@ -821,9 +803,9 @@ public class PacketHandlerClient extends PacketHandler
         if (respawnPacket.respawnDimensionId != mc.thePlayer.dimension)
         {
             started = false;
-            worldClient = new WorldClient(mc, this, worldClient.getLevelData().getRandomSeed(), respawnPacket.respawnDimensionId, respawnPacket.respawnWorldTypeId);
-            worldClient.isClientSide = true;
-            mc.changeWorld(worldClient);
+            worldClientMP = new WorldClientMP(this, worldClientMP.getLevelData().getRandomSeed(), respawnPacket.respawnDimensionId, respawnPacket.respawnWorldTypeId);
+            worldClientMP.isClientSide = true;
+            mc.changeWorld(worldClientMP);
             mc.thePlayer.dimension = respawnPacket.respawnDimensionId;
             mc.displayScreen(new ScreenDownloadTerrain(this));
         }
@@ -836,11 +818,11 @@ public class PacketHandlerClient extends PacketHandler
         Explosion explosion;
         if (explosionPacket.isCannonball)
         {
-            explosion = new ExplosionCannonball(mc.theWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
+            explosion = new ExplosionCannonball(mc.currentWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
         }
         else
         {
-            explosion = new Explosion(mc.theWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
+            explosion = new Explosion(mc.currentWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
         }
         explosion.destroyedBlockPositions = explosionPacket.destroyedBlockPositions;
         //explosion.doExplosionA();
@@ -906,7 +888,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleOpenFlagWindow(FlagOpenPacket flagOpenPacket)
     {
-        TileEntity tileEntity = worldClient.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
+        TileEntity tileEntity = worldClientMP.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
         if (tileEntity instanceof TileEntityFlag)
         {
             TileEntityFlag tileEntityFlag = (TileEntityFlag) tileEntity;
@@ -1019,7 +1001,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleBlockEvent(BlockEventPacket blockEventPacket)
     {
-        mc.theWorld.triggerEvent(blockEventPacket.xLocation, blockEventPacket.yLocation, blockEventPacket.zLocation, blockEventPacket.index, blockEventPacket.data);
+        mc.currentWorld.triggerEvent(blockEventPacket.xLocation, blockEventPacket.yLocation, blockEventPacket.zLocation, blockEventPacket.index, blockEventPacket.data);
     }
 
     @Override
@@ -1037,7 +1019,7 @@ public class PacketHandlerClient extends PacketHandler
     {
         if (mapdataPacket.itemId == Items.MAP.id)
         {
-            ItemMap.getOrCreateSavedData(mapdataPacket.meta, mapdataPacket.scale, mc.theWorld).setColors(mapdataPacket.mapData);
+            ItemMap.getOrCreateSavedData(mapdataPacket.meta, mapdataPacket.scale, mc.currentWorld).setColors(mapdataPacket.mapData);
         }
         else
         {
@@ -1048,7 +1030,7 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handlePlaySoundEffect(PlaySoundEffectPacket playSoundEffectPacket)
     {
-        mc.theWorld.playBlockEvent(playSoundEffectPacket.soundID, playSoundEffectPacket.x, playSoundEffectPacket.y, playSoundEffectPacket.z, playSoundEffectPacket.data);
+        mc.currentWorld.playBlockEvent(playSoundEffectPacket.soundID, playSoundEffectPacket.x, playSoundEffectPacket.y, playSoundEffectPacket.z, playSoundEffectPacket.data);
     }
 
 	@Override
@@ -1131,25 +1113,25 @@ public class PacketHandlerClient extends PacketHandler
     {
         Class<?> clazz = TileEntityDispatcher.getClassFromID(blockEntityDataPacket.tag.getString("id"));
         if (clazz == null) return;
-        TileEntity existingTileEntity = worldClient.getBlockEntity(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
+        TileEntity existingTileEntity = worldClientMP.getBlockEntity(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
         if (existingTileEntity == null || existingTileEntity.getClass() != clazz)
         {
             TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(blockEntityDataPacket.tag);
             if (tileEntity != null)
             {
-                mc.theWorld.setBlockTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
+                mc.currentWorld.setBlockTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
             }
         }
         else
         {
             existingTileEntity.readFromNBT(blockEntityDataPacket.tag);
         }
-        worldClient.markBlockDirty(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
+        worldClientMP.markBlockDirty(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
     }
 
     @Override
     public void handleGameRule(GameRulePacket packet) {
-        LevelData levelData = mc.theWorld.getLevelData();
+        LevelData levelData = mc.currentWorld.getLevelData();
         if (packet.getGameRules() != null) {
             levelData.getGameRules().setValues(packet.getGameRules());
         }
@@ -1184,7 +1166,7 @@ public class PacketHandlerClient extends PacketHandler
 //            System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", packet.data[0], packet.data[1], packet.data[2], packet.data[3]);
             int rainbowTicks = Byte.toUnsignedInt(customPayloadPacket.data[0]) << 24 | Byte.toUnsignedInt(customPayloadPacket.data[1]) << 16 | Byte.toUnsignedInt(customPayloadPacket.data[2]) << 8 | Byte.toUnsignedInt(customPayloadPacket.data[3]);
 //            System.out.println("Added rainbow with " + rainbowTicks + " ticks");
-            worldClient.addRainbow(rainbowTicks);
+            worldClientMP.addRainbow(rainbowTicks);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 012e6b0e0..203c3464d 100644
--- a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -7,6 +7,7 @@ import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.DisconnectPacket;
 import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.PingHandshakePacket;
 
 import java.io.IOException;
 import java.net.InetAddress;
@@ -19,7 +20,6 @@ public class PingPacketHandler
     private final ScreenSelectServer screen;
     private final NetworkManager netManager;
     private final ServerData server;
-    public static long startTime = 0;
 
     public PingPacketHandler(ScreenSelectServer screen, ServerData server)
         throws IOException {
@@ -62,7 +62,7 @@ public class PingPacketHandler
             server.motd = serverInfo[3];
             server.currentPlayers = parseIntWithDefault(serverInfo[4], -1);
             server.maxPlayers = parseIntWithDefault(serverInfo[5], -1);
-            server.latency = System.currentTimeMillis() - startTime;
+            server.latency = System.currentTimeMillis() - PingHandshakePacket.startTime;
 
             screen.handleIncomingServerInfo(server);
 
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 7ad459b83..8d4576d7c 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -414,8 +414,8 @@ public class GameSettings {
 	public void optionChanged(Option<?> option) {
 		if (option == null) return;
 		if (option == difficulty) {
-			if (mc.theWorld != null) {
-				mc.theWorld.setDifficulty(difficulty.value, false);
+			if (mc.currentWorld != null) {
+				mc.currentWorld.setDifficulty(difficulty.value, false);
 			}
 		}
 		if(option == enableVsync) mc.gameWindow.setVsync(enableVsync.value);
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 9ccb98a30..59036f09f 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -50,9 +50,9 @@ public abstract class PlayerController {
 			return;
 		}
 
-		Block mineBlock = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
+		Block mineBlock = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {
-			float mineStrength = mineBlock.blockStrength(mc.theWorld, x, y, z, side, mc.thePlayer);
+			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
 			
 			if(mineStrength < 1.0f) {
 				if(!repeat) {
@@ -76,11 +76,11 @@ public abstract class PlayerController {
 			return;
 		}
 		
-		Block mineBlock = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
+		Block mineBlock = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {	
 			syncCurrentPlayItem();
 			
-			float mineStrength = mineBlock.blockStrength(mc.theWorld, x, y, z, side, mc.thePlayer);
+			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
 			if(mineStrength >= 1.0f) {
 				//Instant Mining
 				
@@ -148,7 +148,7 @@ public abstract class PlayerController {
 	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
 		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		setMineBlock(null, null, null);
-		World world = mc.theWorld;
+		World world = mc.currentWorld;
 		Block block = Block.getBlock(world.getBlockId(x, y, z));
 		if(block == null) return false;
 		
@@ -182,11 +182,11 @@ public abstract class PlayerController {
 	
 	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		if (!mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return;
-		mc.theWorld.onBlockHit(mc.thePlayer, x, y, z, side);
+		mc.currentWorld.onBlockHit(mc.thePlayer, x, y, z, side);
 		
-		Block block = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
+		Block block = Block.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(block != null) {
-			block.onBlockLeftClicked(mc.theWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
+			block.onBlockLeftClicked(mc.currentWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
 		}
 	}
 	
@@ -314,7 +314,7 @@ public abstract class PlayerController {
 	
 	public void playDigSound(Block block, int x, int y, int z) {
 		if(soundDelay <= 0) {
-			mc.theWorld.playBlockSoundEffect(null, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.DIG);
+			mc.currentWorld.playBlockSoundEffect(null, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.DIG);
 			soundDelay = 3;
 		}else {
 			soundDelay--;
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 3c7ced0d4..77314de29 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -26,11 +26,11 @@ public class PlayerControllerMP extends PlayerController {
 
 	@Override
 	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
-		int id = mc.theWorld.getBlockId(x, y, z);
+		int id = mc.currentWorld.getBlockId(x, y, z);
 		boolean removed = super.destroyBlock(x, y, z, side, player);
 		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 		if (item != null) {
-			item.onDestroyBlock(mc.theWorld, id, x, y, z, side, mc.thePlayer);
+			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
 			if (item.stackSize <= 0) {
 				mc.thePlayer.destroyCurrentEquippedItem();
 			}
